"""
This file contains the fields mapping for each endpoint and version related to
MANAGED SYSTEMS.

More info for the fields included in each endpoint and version:
- https://docs.beyondtrust.com/bips/docs/passwordsafe-api
- https://docs.beyondtrust.com/bips/docs/secrets-safe-api
"""

from secrets_safe_library.constants.endpoints import (
    GET_MANAGED_SYSTEMS,
    GET_MANAGED_SYSTEMS_ASSETID,
    GET_MANAGED_SYSTEMS_DATABASEID,
    GET_MANAGED_SYSTEMS_FUNCTIONALACCOUNTID,
    GET_MANAGED_SYSTEMS_MANAGEDSYSTEMID,
    GET_MANAGED_SYSTEMS_WORKGROUPID,
)
from secrets_safe_library.constants.versions import Version

fields = {
    GET_MANAGED_SYSTEMS: {
        Version.DEFAULT: [
            "ManagedSystemID",
            "EntityTypeID",
            "AssetID",
            "DatabaseID",
            "DirectoryID",
            "CloudID",
            "WorkgroupID",
            "HostName",
            "DnsName",
            "IPAddress",
            "InstanceName",
            "IsDefaultInstance",
            "Template",
            "ForestName",
            "UseSSL",
            "OracleInternetDirectoryID",
            "OracleInternetDirectoryServiceName",
            "SystemName",
            "PlatformID",
            "NetBiosName",
            "Port",
            "Timeout",
            "Description",
            "ContactEmail",
            "PasswordRuleID",
            "DSSKeyRuleID",
            "ReleaseDuration",
            "MaxReleaseDuration",
            "ISAReleaseDuration",
            "AutoManagementFlag",
            "FunctionalAccountID",
            "LoginAccountID",
            "ElevationCommand",
            "SshKeyEnforcementMode",
            "CheckPasswordFlag",
            "ChangePasswordAfterAnyReleaseFlag",
            "ResetPasswordOnMismatchFlag",
            "ChangeFrequencyType",
            "ChangeFrequencyDays",
            "ChangeTime",
            "AccountNameFormat",
            "RemoteClientType",
            "ApplicationHostID",
            "IsApplicationHost",
            "AccessURL",
        ],
    },
    GET_MANAGED_SYSTEMS_MANAGEDSYSTEMID: {
        Version.DEFAULT: [
            "ManagedSystemID",
            "EntityTypeID",
            "AssetID",
            "DatabaseID",
            "DirectoryID",
            "CloudID",
            "WorkgroupID",
            "HostName",
            "DnsName",
            "IPAddress",
            "InstanceName",
            "IsDefaultInstance",
            "Template",
            "ForestName",
            "UseSSL",
            "OracleInternetDirectoryID",
            "OracleInternetDirectoryServiceName",
            "SystemName",
            "PlatformID",
            "NetBiosName",
            "Port",
            "Timeout",
            "Description",
            "ContactEmail",
            "PasswordRuleID",
            "DSSKeyRuleID",
            "ReleaseDuration",
            "MaxReleaseDuration",
            "ISAReleaseDuration",
            "AutoManagementFlag",
            "FunctionalAccountID",
            "LoginAccountID",
            "ElevationCommand",
            "SshKeyEnforcementMode",
            "CheckPasswordFlag",
            "ChangePasswordAfterAnyReleaseFlag",
            "ResetPasswordOnMismatchFlag",
            "ChangeFrequencyType",
            "ChangeFrequencyDays",
            "ChangeTime",
            "AccountNameFormat",
            "RemoteClientType",
            "ApplicationHostID",
            "IsApplicationHost",
            "AccessURL",
        ],
    },
    GET_MANAGED_SYSTEMS_ASSETID: {
        Version.DEFAULT: [
            "ManagedSystemID",
            "EntityTypeID",
            "AssetID",
            "DatabaseID",
            "DirectoryID",
            "CloudID",
            "WorkgroupID",
            "HostName",
            "DnsName",
            "IPAddress",
            "InstanceName",
            "IsDefaultInstance",
            "Template",
            "ForestName",
            "UseSSL",
            "OracleInternetDirectoryID",
            "OracleInternetDirectoryServiceName",
            "SystemName",
            "PlatformID",
            "NetBiosName",
            "Port",
            "Timeout",
            "Description",
            "ContactEmail",
            "PasswordRuleID",
            "DSSKeyRuleID",
            "ReleaseDuration",
            "MaxReleaseDuration",
            "ISAReleaseDuration",
            "AutoManagementFlag",
            "FunctionalAccountID",
            "LoginAccountID",
            "ElevationCommand",
            "SshKeyEnforcementMode",
            "CheckPasswordFlag",
            "ChangePasswordAfterAnyReleaseFlag",
            "ResetPasswordOnMismatchFlag",
            "ChangeFrequencyType",
            "ChangeFrequencyDays",
            "ChangeTime",
            "AccountNameFormat",
            "RemoteClientType",
            "ApplicationHostID",
            "IsApplicationHost",
            "AccessURL",
        ],
    },
    GET_MANAGED_SYSTEMS_DATABASEID: {
        Version.DEFAULT: [
            "ManagedSystemID",
            "EntityTypeID",
            "AssetID",
            "DatabaseID",
            "DirectoryID",
            "CloudID",
            "WorkgroupID",
            "HostName",
            "DnsName",
            "IPAddress",
            "InstanceName",
            "IsDefaultInstance",
            "Template",
            "ForestName",
            "UseSSL",
            "OracleInternetDirectoryID",
            "OracleInternetDirectoryServiceName",
            "SystemName",
            "PlatformID",
            "NetBiosName",
            "Port",
            "Timeout",
            "Description",
            "ContactEmail",
            "PasswordRuleID",
            "DSSKeyRuleID",
            "ReleaseDuration",
            "MaxReleaseDuration",
            "ISAReleaseDuration",
            "AutoManagementFlag",
            "FunctionalAccountID",
            "LoginAccountID",
            "ElevationCommand",
            "SshKeyEnforcementMode",
            "CheckPasswordFlag",
            "ChangePasswordAfterAnyReleaseFlag",
            "ResetPasswordOnMismatchFlag",
            "ChangeFrequencyType",
            "ChangeFrequencyDays",
            "ChangeTime",
            "AccountNameFormat",
            "RemoteClientType",
            "ApplicationHostID",
            "IsApplicationHost",
            "AccessURL",
        ],
    },
    GET_MANAGED_SYSTEMS_FUNCTIONALACCOUNTID: {
        Version.DEFAULT: [
            "ManagedSystemID",
            "EntityTypeID",
            "AssetID",
            "DatabaseID",
            "DirectoryID",
            "CloudID",
            "WorkgroupID",
            "HostName",
            "DnsName",
            "IPAddress",
            "InstanceName",
            "IsDefaultInstance",
            "Template",
            "ForestName",
            "UseSSL",
            "OracleInternetDirectoryID",
            "OracleInternetDirectoryServiceName",
            "SystemName",
            "PlatformID",
            "NetBiosName",
            "Port",
            "Timeout",
            "Description",
            "ContactEmail",
            "PasswordRuleID",
            "DSSKeyRuleID",
            "ReleaseDuration",
            "MaxReleaseDuration",
            "ISAReleaseDuration",
            "AutoManagementFlag",
            "FunctionalAccountID",
            "LoginAccountID",
            "ElevationCommand",
            "SshKeyEnforcementMode",
            "CheckPasswordFlag",
            "ChangePasswordAfterAnyReleaseFlag",
            "ResetPasswordOnMismatchFlag",
            "ChangeFrequencyType",
            "ChangeFrequencyDays",
            "ChangeTime",
            "AccountNameFormat",
            "RemoteClientType",
            "ApplicationHostID",
            "IsApplicationHost",
            "AccessURL",
        ],
    },
    GET_MANAGED_SYSTEMS_WORKGROUPID: {
        Version.DEFAULT: [
            "ManagedSystemID",
            "EntityTypeID",
            "AssetID",
            "DatabaseID",
            "DirectoryID",
            "CloudID",
            "WorkgroupID",
            "HostName",
            "DnsName",
            "IPAddress",
            "InstanceName",
            "IsDefaultInstance",
            "Template",
            "ForestName",
            "UseSSL",
            "OracleInternetDirectoryID",
            "OracleInternetDirectoryServiceName",
            "SystemName",
            "PlatformID",
            "NetBiosName",
            "Port",
            "Timeout",
            "Description",
            "ContactEmail",
            "PasswordRuleID",
            "DSSKeyRuleID",
            "ReleaseDuration",
            "MaxReleaseDuration",
            "ISAReleaseDuration",
            "AutoManagementFlag",
            "FunctionalAccountID",
            "LoginAccountID",
            "ElevationCommand",
            "SshKeyEnforcementMode",
            "CheckPasswordFlag",
            "ChangePasswordAfterAnyReleaseFlag",
            "ResetPasswordOnMismatchFlag",
            "ChangeFrequencyType",
            "ChangeFrequencyDays",
            "ChangeTime",
            "AccountNameFormat",
            "RemoteClientType",
            "ApplicationHostID",
            "IsApplicationHost",
            "AccessURL",
        ],
    },
}
